using System;
using System.Data;
using System.Configuration;
using System.IO; 
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using System.Xml;
using TuxWebService;

public partial class _Admin : System.Web.UI.Page 
{
    public const int TRUE = 1;

    //Update Settings Constants
    public const int UPDATE_SUCCESSFUL = 1;
    public const int UPDATE_FAILED = 0;
    public const int UPDATE_NOREPLICATION = -1;

    // Launcher Errors
    public const int LAUNCHER_ERROR_NOERROR = 0x00;
    public const int LAUNCHER_ERROR_CONNECT = 0x01;
    public const int LAUNCHER_ERROR_LOGON = 0x02;
    public const int LAUNCHER_ERROR_LOGONPWDCHANGE = 0x03;
    public const int LAUNCHER_ERROR_NETWORKERROR = 0x04;
    public const int LAUNCHER_ERROR_OUTOFMEMORY = 0x05;
    public const int LAUNCHER_ERROR_NOXML = 0x06;
    public const int LAUNCHER_ERROR_NOCONTROLLER = 0x07;
    public const int LAUNCHER_ERROR_NOSSL = 0x08;
    public const int LAUNCHER_ERROR_INVALIDCERFIFICATE = 0x09;

    public const int WEBSERVICE_ERROR_SETTINGSCHANGED = 0x00000100;

    // New Authentication Errors
    public const int NEWAUTH_ERROR_SUCCESS = 0x00;
    public const int NEWAUTH_ERROR_SUCCESS_SERVEROTP = 0x01;
    public const int NEWAUTH_ERROR_CONN_FAILED = 0x02;
    public const int NEWAUTH_ERROR_MUST_CHANGE_PWD = 0x0D;
    public const int NEWAUTH_ERROR_CHANGEPWD_FAILED = 0x11;

    // New Authentication States
    public const int NA_STATE_INIT = 1;
    public const int NA_STATE_CONNECT = 2;
    public const int NA_STATE_IDENTIFY = 3;
    public const int NA_STATE_PROVIDELOGON = 4;
    public const int NA_STATE_PROVIDEACCINFO = 5;
    public const int NA_STATE_CHANGEPWD = 6;
    public const int NA_STATE_READY = 7;

    // New Authentication Method Types
    public const int NA_TYPE_OTP = 1;
    public const int NA_TYPE_OTPCC = 2;
    public const int NA_TYPE_PASSWORD = 3;

    // New Authentication Method Flags
    public const int NA_TOKEN_INACTIVE = 0x00000002;
    public const int NA_TOKEN_ACTIVATE_SMS = 0x00000004;
    public const int NA_TOKEN_ACTIVATE_EMAIL = 0x00000008;
    public const int NA_OTP_REQUEST_SMS = 0x00000010;
    public const int NA_OTP_REQUEST_EMAIL = 0x00000020;

    // Controller States
    public const int CONTROLLER_APPLIST_REPLY_SUCCESS = 0;
    public const int CONTROLLER_APPLIST_REPLY_SUCCESS_SERVEROTP = 1;
    public const int CONTROLLER_APPLIST_REPLY_NOTALLOWED = 4;

    public const int RET_CLIENT_USERPROPERTY_SUCCESS = 0;
    public const int RET_CLIENT_USERPROPERTY_FAILED = 1;
    public const int RET_CLIENT_USERPROPERTY_NEEDSAUTH = 2;

    protected void Page_Init(object sender, EventArgs e)
    {
        //txtServiceUrl.Text = "http://localhost:" + Request.ServerVariables["SERVER_PORT"] + "/2XWebservice/2XWebService.asmx";
        txtServiceUrl.Text = "http://localhost:81/2XWebservice/2XWebService.asmx";
    }

    protected void Page_Load(object sender, EventArgs e)
    {
    }

    protected void btnLogOn_Click(object sender, EventArgs e)
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];

        uint dwRet = service.AdminLogon(txtUserName.Text, txtPassword.Text);
        if (dwRet >> 16 == TRUE)
        {
            lblLoginResult.Text = "Login Successful";

            pnlNewFarm.Visible = true;
            pnlLogging.Visible = true;
            pnlLogoff.Visible = true;
            DataSet dsSettings = service.GetSettings();

            DataTable setting = dsSettings.Tables["WSSettings"];

            String expresion;
            expresion = "Attribute = 'EnableLogging'";
            DataRow[] result = setting.Select(expresion);
            if (result.Length > 0)
                cbEnableLogging.Checked = result[0]["Value"].Equals("True");
            else
                cbEnableLogging.Checked = false;

            UpdateLogFileText();
        }
        else lblLoginResult.Text = "Login Failed";
    }

    protected void btnNewFarm_Click(object sender, EventArgs e)
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];

        DataSet ds = service.GetSettings();

        if (ds == null)
            return;
        
        string expression = "PriServer = '" + txtNewFarm.Text.ToLower() + "'";
        DataRow[] result = ds.Tables["Farms"].Select(expression);

        if (result.Length > 0)
        {
            lblNewFarm.Visible = true;
            lblNewFarm.Text = "New Farm Already Exist";
        }
        else
        {
            DataRow row = ds.Tables["Farms"].NewRow();
            row["Alias"] = txtNewFarm.Text;
            row["PriServer"] = txtNewFarm.Text;
            row["SecServer"] = "";
            row["Port"] = 80;
            row["SSLPort"] = 443;
            row["UseSSL"] = false;

            row["OverrideGWIP"] = false;
            row["PriGateway"] = "";
            row["SecGateway"] = "";
            row["OverrideGWPort"] = false;
            row["GatewayPort"] = 80;
            row["OverrideGWSSLPort"] = false;
            row["GatewaySSLPort"] = 443;
            row["DefConnType"] = 0;
            ds.Tables["Farms"].Rows.Add(row);

            int nRetValue = service.UpdateSettings(ds);

            if (nRetValue == UPDATE_NOREPLICATION || nRetValue == UPDATE_SUCCESSFUL)
            {
                lblNewFarm.Text = "New Farm Added!";
                UpdateFarms();
                //not adding 1 to the settingsID as getSettings() is being called before updating.
            }
            else if (nRetValue == UPDATE_FAILED)
                lblNewFarm.Text = "Failed!";

            UpdateLogFileText();
        }
    }

    protected void btnLogOut_Click(object sender, EventArgs e)
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];
        service.Logoff();
        lblLoginResult.Text = String.Empty;

        pnlNewFarm.Visible = false;
        pnlLogging.Visible = false;
        pnlLogging.Visible = false;
    }

    protected void btnAccept_Click(object sender, EventArgs e)
    {
        try
        {
            TUXWebServiceClass service = new TUXWebServiceClass();
            service.Url = txtServiceUrl.Text;

            //make sure session remains the same when switching pages
            service.CookieContainer = new System.Net.CookieContainer();

            Session["current"] = service;

            //get Module Version
            string reply = service.GetModulesVersion();
            XmlDocument doc = new XmlDocument();
            doc.LoadXml(reply);

            lblVersion.Text = "Application Listing : ";
            lblVersion.Text += doc.SelectSingleNode("/ModulesVer/AppList").InnerText;
            lblVersion.Text += "<br>Web Server : ";
            lblVersion.Text += doc.SelectSingleNode("/ModulesVer/WebServer").InnerText;
            lblVersion.Text += "<br>WebPortal Sample : ";

            string fileVersion = Request.ServerVariables["APPL_PHYSICAL_PATH"] + "Version.txt";
            StreamReader sr = new StreamReader(new FileStream(fileVersion, FileMode.Open, FileAccess.Read));
            lblVersion.Text += sr.ReadLine();

            UpdateFarms();

            pnlAdminLogon.Visible = true;
            pnlLogging.Visible = false;
            pnlLogoff.Visible = false;
            pnlDetails.Visible = true;

            lblWebserviceError.Text = string.Empty;
        }
        catch
        {
            Session["current"] = null;
            lblWebserviceError.Text = "Unable to find webservice";
        }
    }

    protected void UpdateFarms()
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];

        //getting list of available farms
        DataSet farms = service.GetListOfFarms();

        lblFarms.Text = "<table border = 1><tr><td>ID</td><td>Alias</td><td>Server Name</td></tr>";
        foreach (DataRow myRow in farms.Tables[0].Rows)
        {
            lblFarms.Text += "<tr><td>" + myRow[0] + "</td><td>";
            lblFarms.Text += myRow[1] + "</td><td>";
            lblFarms.Text += myRow[2] + "</td></tr>";
        }
        lblFarms.Text += "</table>";
    }

    protected void UpdateLogFileText()
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];
        if (service == null)
            return;

        tbLogText.InnerText = service.GetLogFile();
    }

    protected void btClearLog_Click(object sender, EventArgs e)
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];
        if (service == null)
            return;

        service.ClearLogFile();
        
        //clearing the text area
        tbLogText.InnerText = "";

        lblLog.Text = "Log Cleared";
    }

    protected void btGetLogRep_Click(object sender, EventArgs e)
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];
        if (service == null)
            return;

        String sRepositry = service.GetLogRepositry();

        if (sRepositry.Length > 0)
        {
            byte[] repositryBin = Convert.FromBase64String(sRepositry);
            // Writing log to output stream
            Context.Response.AddHeader("Content-Disposition", "attachment; filename=log.zip");
            Context.Response.ContentType = "application/x-zip-compressed";

            // Writing data to output stream
            Context.Response.BinaryWrite(repositryBin);
        }
        else
        {
            lblLog.Text = "No Repositary file found";
        }
    }

    protected void btnEnableLogging_Click(object sender, EventArgs e)
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];

        DataSet ds = service.GetSettings();

        if (ds == null)
            return;

        String expresion;
        expresion = "Attribute = 'EnableLogging'";
        ds.Tables["WSSettings"].Select(expresion)[0]["Value"] = true;

        int nRetValue = service.UpdateSettings(ds);

        if (nRetValue == UPDATE_NOREPLICATION || nRetValue == UPDATE_SUCCESSFUL)
        {
            lblLoggingEnabled.Text = "'Enabled Logging' State Changed!";
            cbEnableLogging.Checked = true;
        }
        else if (nRetValue == UPDATE_FAILED)
            lblNewFarm.Text = "'Enabled Logging' State Change Failed!";
    }

    protected void btnDisableLogging_Click(object sender, EventArgs e)
    {
        TUXWebServiceClass service = (TUXWebServiceClass)Session["current"];

        DataSet ds = service.GetSettings();

        if (ds == null)
            return;

        String expresion;
        expresion = "Attribute = 'EnableLogging'";
        ds.Tables["WSSettings"].Select(expresion)[0]["Value"] = false;

        int nRetValue = service.UpdateSettings(ds);

        if (nRetValue == UPDATE_NOREPLICATION || nRetValue == UPDATE_SUCCESSFUL)
        {
            lblLoggingEnabled.Text = "'Enabled Logging' State Changed!";
            cbEnableLogging.Checked = false;            
        }
        else if (nRetValue == UPDATE_FAILED)
            lblNewFarm.Text = "'Enabled Logging' State Change Failed!";
    }
}
    